#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of fibonacci  */
/**********************************************************/
#include <stdio.h>
#include <stdlib.h>
int _expandSize = 16;
int _minBlockSize = 16;
void fib_block_bf(int *sum,_BlockStack *_stack,int _depth);
void fib_block_df0(int *sum,_BlockStack *_stack,int _depth);
void fib_block_df1(int *sum,_BlockStack *_stack,int _depth);
void fib(int n0,int n1,int *sum);

void fib(int n0,int n1,int *sum)
{
  if ((n0 == 1) || (n0 == 0)) {
     *sum += 1;
  }
  else {
    fib((n0 - 1),(n0 - 2),sum);
  }
  if ((n1 == 1) || (n1 == 0)) {
     *sum += 1;
  }
  else {
    fib((n1 - 1),(n1 - 2),sum);
  }
}
/*Benchmark entrance called by harness*/

int main(int argc,char **argv)
{
  if (argc < 2) {
    printf("number of fibonacci required\n");
    return 1;
  }
  if (argc > 3) {
    printf("extra arguments being ignored\n");
    return 1;
  }
  int n = atoi(argv[1]);
  if (n < 2) {
    printf("Please input a number greater than 1\n");
    return 1;
  }
  _minBlockSize = 2;
  printf("running fibonacci %d\n",n);
  if (argc > 2) {
    _expandSize = atoi(argv[2]);
    printf("_expandSize is: %d\n",_expandSize);
  }
  int n0 = (n - 1);
  int n1 = (n - 2);
  int sum = 0;
  
#pragma recursionCallEntry
  fib(n0,n1,&sum);
  printf("This is the result: %d\n",sum);
  return 0;
}
