#!/usr/bin/python

import sys, getopt

def generateLargerDataSet(inputfile, outputfile):
    finput = open(inputfile, "r")
    foutput = open(outputfile, "w")
    fll = []
    fllold = []
    offset = 0
    for line in finput:
        fllold.append(line)
        ll = line.split()
        if (ll[0] == 'p'):
            offset = int(ll[2])
            ll[2] = str(int(ll[2]) * 2)
            ll[3] = str(int(ll[3]) * 2)
        elif (ll[0] == 'e'):
            ll[1] = str(int(ll[1]) + offset)
            ll[2] = str(int(ll[2]) + offset)
        newline = ""
        for l in ll: newline += l + " "
        newline = newline[:-1] + "\n"
        fll.append(newline)

    header = []
    header.append(fll[0])
    fll = header + fllold[1:] + fll[1:]
    for l in fll: foutput.write(l)

    finput.close()
    foutput.close()

def main(argv):
    inputfile = ""
    outputfile = ""

    try:
        opts, args = getopt.getopt(argv, "hi:o:", ["ifile=", "ofile="])
    except getopt.GetoptError:
        print "translater.py -i <inputfile> -o <outputfile>"
        sys.exit(2)
    for opt, arg in opts:
        if opt == "-h":
            print "translater.py -i <inputfile> -o <outputfile>"
            sys.exit()
        elif opt in ("-i", "--ifile"):
            inputfile = arg
        elif opt in ("-o", "--ofile"):
            outputfile = arg
    print "Input file is ", inputfile
    print "Output file is ", outputfile

    generateLargerDataSet(inputfile, outputfile)

if __name__ == '__main__':
    main(sys.argv[1:])



