#include "block.h"
class _BlockStack ;
/**********************************************************/
/* This code is for PLDI-15 Artifact Evaluation only      */
/* and will be released with further copyright information*/
/* File: Basic sequential recursive version of binomial  */
/**********************************************************/
#include <stdio.h>
#include <stdlib.h>
int _expandSize = 16;
int _minBlockSize = 16;
void binomial_block_bf(char n,int *num,_BlockStack *_stack,int _depth);
void binomial_block_df0(char n,int *num,_BlockStack *_stack,int _depth);
void binomial_block_df1(char n,int *num,_BlockStack *_stack,int _depth);
void binomial(char n,char k0,char k1,int *num);

void binomial(char n,char k0,char k1,int *num)
{
  if ((k0 == 0) || (k0 == n)) {
     *num += 1;
  }
  else if ((k0 < 0) || (k0 > n)) {
  }
  else {
    binomial((n - 1),k0,(k0 - 1),num);
  }
  if ((k1 == 0) || (k1 == n)) {
     *num += 1;
  }
  else if ((k1 < 0) || (k1 > n)) {
  }
  else {
    binomial((n - 1),k1,(k1 - 1),num);
  }
}
/*Benchmark entrance called by harness*/

int main(int argc,char **argv)
{
  if (argc < 3) {
    printf("number of binomial required -- n, k\n");
    return 1;
  }
  if (argc > 4) {
    printf("extra arguments being ignored\n");
    return 1;
  }
  int n = atoi(argv[1]);
  int k = atoi(argv[2]);
  if ((((k == 0) || (k == n)) || (k < 0)) || (k > n)) {
    return 1;
  }
  _minBlockSize = 2;
  printf("running binomial %d, %d\n",n,k);
  if (argc > 3) {
    _expandSize = atoi(argv[3]);
    printf("_expandSize is: %d\n",_expandSize);
  }
  int k0 = k;
  int k1 = (k - 1);
  n = (n - 1);
  int num = 0;
  
#pragma recursionCallEntry
  binomial(n,k0,k1,&num);
  printf("This is the result: %d\n",num);
  return 0;
}
